//+------------------------------------------------------------------+ 
//|                                    _TRO_RANGE_Info               | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 


//---- indicator settings 
#property  indicator_separate_window 
#property  indicator_buffers 2 
#property  indicator_color1  Red 
#property  indicator_color2  Green 

//---- indicator buffers 
double     RANGEBuffer[]; 
double     RANGEBuffer1[]; 

//---- indicator parameters  
extern int   Threshold=20; 
extern color CurrentBarColor = White; 
extern color ThresholdColor  = Aqua; 

//+------------------------------------------------------------------+
extern bool show.info=true;
extern bool show.hist=true;
extern int price.x.offset= 250;//250
extern int price.y.offset= -160;//-190
extern int win = 1;
//+------------------------------------------------------------------+
double rng,sum.rng,avg.rng;

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 

//---- drawing settings 
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2); 
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2); 
//---- indicator buffers mapping 
   SetIndexBuffer(0,RANGEBuffer); 
   SetIndexBuffer(1,RANGEBuffer1);  
//---- name for DataWindow and indicator subwindow label 
   IndicatorShortName("RANGE"); 
   SetIndexLabel(0,"RANGE"); 
   SetIndexLabel(1,"RANGE"); 

//---- initialization done 
   return(0); 
  } 
int deinit() 
{ 
   ObjectDelete("CurrentBarValue"); 
   ObjectDelete("LabelCurrentBarValue");  
   
  ObjectsDeleteAll(win,OBJ_HLINE);
  ObjectsDeleteAll(win,OBJ_TEXT);
  ObjectsDeleteAll(win,OBJ_LABEL);
}  
//+------------------------------------------------------------------+ 
//| Range                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   double HighVal,LowVal, RangeVal, xRange; 
   int limit; 
   int counted_bars=IndicatorCounted(); 
   
   rng=0;
   sum.rng=0;
   avg.rng=0;

   
//---- last counted bar will be recounted 
  if(counted_bars>0) counted_bars--; 
  limit=Bars-counted_bars; 
//---- RANGE counted in the 1-st buffer 
   for(int i=0; i<limit; i++) 
   { 
     HighVal  = iHigh(NULL,0,i);        
     LowVal   = iLow(NULL,0,i); 

     rng      = HighVal - LowVal ;
     sum.rng  = sum.rng + rng;

if (show.hist) { 
     
     RangeVal  = ( rng ) /Point ;
     
     if (RangeVal   >= Threshold) { RANGEBuffer1[i] = RangeVal  ; } 
     else { RANGEBuffer[i] = RangeVal  ; } 
     

   
   
     // Draw Threshold line 
     int win_idx=WindowFind("RANGE"); 
 
/*
     ObjectDelete("Threshold"); 
     ObjectCreate("Threshold", OBJ_HLINE, win_idx, Time[0], Threshold); 
     ObjectSet("Threshold", OBJPROP_COLOR, ThresholdColor); 
     ObjectSet("Threshold", OBJPROP_STYLE, STYLE_SOLID); 
     ObjectSet("Threshold", OBJPROP_WIDTH, 1); 
     ObjectSet("Threshold", OBJPROP_BACK, true); 
    
     // Label for Threshold 
//     ObjectDelete("LabelThreshold"); 
//     ObjectCreate("LabelThreshold", OBJ_TEXT, win_idx, Time[0], Threshold); 
     ObjectSet("LabelThreshold", OBJPROP_COLOR, ThresholdColor); 
     ObjectSetText("LabelThreshold", "Threshold",8); 
    ObjectSet("LabelThreshold", OBJPROP_ANGLE, 0); 
*/      

     xRange   = (iHigh(NULL,0,0) - iLow(NULL,0,0) ) /Point ;
/*     
     // Draw Current Bar line value 
     ObjectDelete("CurrentBarValue"); 
     ObjectCreate("CurrentBarValue", OBJ_HLINE, win_idx, Time[0], xRange ); 
     ObjectSet("CurrentBarValue", OBJPROP_COLOR, CurrentBarColor); 
     ObjectSet("CurrentBarValue", OBJPROP_STYLE, STYLE_SOLID); 
     ObjectSet("CurrentBarValue", OBJPROP_WIDTH, 1); 
     ObjectSet("CurrentBarValue", OBJPROP_BACK, true); 
         
     // Label per Current Bar Line 
     ObjectDelete("LabelCurrentBarValue"); 
     ObjectCreate("LabelCurrentBarValue", OBJ_TEXT, win_idx, Time[0], (iHigh(NULL,0,0)-iLow(NULL,0,0))/Point); 
     ObjectSet("LabelCurrentBarValue", OBJPROP_COLOR, CurrentBarColor); 
     ObjectSetText("LabelCurrentBarValue", "Current Bar value",8); 
     ObjectSet("LabelCurrentBarValue", OBJPROP_ANGLE, 0);    
*/    
   
       
   }  // if (show.hist)
   
   int db=iBars(Symbol(),Period());
   avg.rng=sum.rng/db/Point;   
    
   } // for(int i=0; i<limit; i++) 

//+------------------------------------------------------------------+   
//+------------------------------------------------------------------+
if (show.info) {    

   ObjectCreate("RNG630", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG630","RANGE", 30, "Arial Bold", Gray);
   ObjectSet("RNG630", OBJPROP_CORNER, 0);
   ObjectSet("RNG630", OBJPROP_XDISTANCE, 760+price.x.offset);
   ObjectSet("RNG630", OBJPROP_YDISTANCE, 160+price.y.offset);
/*
   ObjectCreate("RNG629", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG629",DoubleToStr(next.res,Digits), 15, "Arial Bold", Red);
   ObjectSet("RNG629", OBJPROP_CORNER, 0);
   ObjectSet("RNG629", OBJPROP_XDISTANCE, 770+price.x.offset);
   ObjectSet("RNG629", OBJPROP_YDISTANCE, 197+price.y.offset);
   
   ObjectCreate("RNG629b", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG629b",DoubleToStr(next.sup,Digits), 15, "Arial Bold", Blue);
   ObjectSet("RNG629b", OBJPROP_CORNER, 0);
   ObjectSet("RNG629b", OBJPROP_XDISTANCE, 770+price.x.offset);
   ObjectSet("RNG629b", OBJPROP_YDISTANCE, 260+price.y.offset);                 
*/                    
   ObjectCreate("RNG631", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG631",DoubleToStr(xRange,0), 40, "Arial Bold", LightGray);
   ObjectSet("RNG631", OBJPROP_CORNER, 0);
   ObjectSet("RNG631", OBJPROP_XDISTANCE, 765+price.x.offset);
   ObjectSet("RNG631", OBJPROP_YDISTANCE, 210+price.y.offset); 
           
/*
   ObjectCreate("RNG632", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG632",DoubleToStr(avg.rng,2), 15, "Arial Bold", LimeGreen);
   ObjectSet("RNG632", OBJPROP_CORNER, 0);
   ObjectSet("RNG632", OBJPROP_XDISTANCE, 860+price.x.offset);
   ObjectSet("RNG632", OBJPROP_YDISTANCE, 197+price.y.offset);
                   
   ObjectCreate("RNG634", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG634",DoubleToStr(db,0), 10, "Arial Bold", Silver);
   ObjectSet("RNG634", OBJPROP_CORNER, 0);
   ObjectSet("RNG634", OBJPROP_XDISTANCE, 860+price.x.offset);
   ObjectSet("RNG634", OBJPROP_YDISTANCE, 260+price.y.offset);    
*/   
/*  
   ObjectCreate("RNG634a", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG634a",DoubleToStr(s,Digits-4), 15, "Arial Bold", Yellow);
   ObjectSet("RNG634a", OBJPROP_CORNER, 0);
   ObjectSet("RNG634a", OBJPROP_XDISTANCE, 900+price.x.offset);
   ObjectSet("RNG634a", OBJPROP_YDISTANCE, 280+price.y.offset);
   
   ObjectCreate("RNG634b", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG634b",DoubleToStr(m,Digits-4)+" : "+DoubleToStr(s,Digits-4), 15, "Arial Bold", Yellow);
   ObjectSet("RNG634b", OBJPROP_CORNER, 0);
   ObjectSet("RNG634b", OBJPROP_XDISTANCE, 870+price.x.offset);
   ObjectSet("RNG634b", OBJPROP_YDISTANCE, 280+price.y.offset); 
   
   ObjectCreate("t634b", OBJ_LABEL, win, 0, 0);
   ObjectSetText("t634b","Time Left", 15, "Arial Bold", Gray);
   ObjectSet("t634b", OBJPROP_CORNER, 0);
   ObjectSet("t634b", OBJPROP_XDISTANCE, 765+price.x.offset);
   ObjectSet("t634b", OBJPROP_YDISTANCE, 280+price.y.offset);   
*/
//+------------------------------------------------------------------+  
   WindowRedraw();    
} 
//---- done 
   return(0); 
  } 